this.name			= "KW_adder_mark_III";
this.author			= "Montana05";
this.description	= "event handler for the Addder Mark III OXP";
this.version		= "1.50";
this.copyright		= "2022 Montana05";
this.licence		= "CC BY-NC-SA 4.0";
"use strict";

this.shipSpawned = function(ship)
{
	if(ship.dataKey.search(/KW_adder_mark_III/i) < 0 || ship.isPlayer)
	{
		return;
	}
	else
	{
		var shipType = ship.dataKey;
		var shipRole = ship.primaryRole;
		var cargoLoad = ship.cargoSpaceUsed;

		// setup escape pods
		if(ship.hasRole("escape-capsule"))
		{
			let crewName = expandDescription("[nom]");
			let crewDescription = "a crew member of an evacuated ship";
			let crewRole = "hunter";  // the role is not particular important anymore, all data will be added by the script
			let crewRace = expandDescription("[KW_adder_mark_III_races_scientific]");  // add a race to the crew members
			let crewRank = expandDescription("[KW_adder_mark_III_crew_civil_small]");
			let crewInsurance = this.$getRndInteger(90, 450);
			let crewBounty = 0;
			
			switch(shipType) 
			{
				case "KW_adder_mark_III_escape_capsule_std_green":
				case "KW_adder_mark_III_escape_capsule_std_blue":

					crewName = ("the " + crewRace + " " + crewRank + " " + expandDescription("[nom]"));
					crewDescription = "a ship crew member";
					crewRole = "trader";
					crewInsurance = this.$getRndInteger(90, 450);
					break;

				case "KW_adder_mark_III_escape_capsule_std_red":
					
					crewName = ("the " + crewRace + " " + crewRank + " " + expandDescription("[nom]"));
					crewDescription = "a ship crew member";
					crewRole = "hunter";
					crewInsurance = this.$getRndInteger(90, 450);
					break;	
				
				case "KW_adder_mark_III_escape_capsule_std_green_criminal":
				case "KW_adder_mark_III_escape_capsule_std_blue_criminal":
				case "KW_adder_mark_III_escape_capsule_std_red_criminal":

					crewName = ("the " + crewRace + " " + expandDescription("[nom]"));
					crewDescription = "a " + expandDescription("[KW_adder_mark_III_criminals]") +  "wanted by GalCop police";
					crewRole = "pirate";
					crewBounty = crewInsurance + (15 * system.government);  // stable governments pay extra bonus
					crewInsurance = 0;
					break;

				case "KW_adder_mark_III_escape_capsule_std_green_pirate":
				case "KW_adder_mark_III_escape_capsule_std_blue_pirate":
				case "KW_adder_mark_III_escape_capsule_std_red_pirate":	

					crewName = ("the " + crewRace + " " + expandDescription("[KW_adder_mark_III_pirate_nicknames]") + expandDescription("[nom]"));
					crewDescription = "a " + expandDescription("[KW_adder_mark_III_criminals]") +  "wanted by GalCop police";
					crewRole = "pirate";
					crewBounty = (crewInsurance * 1.25) + (25 * system.government);  // stable governments pay extra bonus
					crewInsurance = 0;
					break;
					
				default: 
	
					break;
			};

			ship.setCrew
			(
				{
					name: crewName,
					short_description: crewDescription,
					role: crewRole,
					species: crewRace,
					insurance: crewInsurance,
					bounty: crewBounty
				}
			);

			// removes individual roles
			ship.primaryRole = "escape-capsule";
		}
		else
		{
			switch(shipRole) 
			{
				case "trader":
				case "pirate":
				case "pirate-light-freighter":
				case "KW_adder_mark_III_01":
				case "KW_adder_mark_III-E_pirate":
								
					if(shipRole == "KW_adder_mark_III_01")
					{
						ship.primaryRole = "trader";
					};

					if(shipRole == "KW_adder_mark_III-E_pirate")
					{
						ship.primaryRole = "pirate";
					};
				
					while(ship.cargoSpaceUsed <= 1)  // makes sure that there is some cargo
					{
						if(this.$getRndInteger(1, 6) < 4)
						{
							ship.setCargoType("PLENTIFUL_GOODS");
						}
						else
						{
							ship.setCargoType("SCARCE_GOODS");
						};
					};	
					break;

				case "trader-courier":
								
					if(cargoLoad <= 1)
					{
						for(var i = this.$getRndInteger(5, 10) - 1 ; i >= 0 ; --i)
						{
							ship.adjustCargo(this.$KW_adder_mark_III_rare_cargo(), 1);
						};
					};
					break;	

				case "trader-smuggler":
				case "KW_adder_mark_III_02":
				
					ship.primaryRole = "trader-smuggler";
				
					while(ship.cargoSpaceUsed <= 1)  // makes sure that there is some cargo
					{
						if(this.$getRndInteger(1, 6) < 4)
						{
							ship.setCargoType("ILLEGAL_GOODS");
						}
						else
						{
							ship.setCargoType("PIRATE_GOODS");
						};
					};	
					break;
				
				case "scavenger":
				
					if(cargoLoad <= 1)
					{
						for(var i = this.$getRndInteger(5, 10) - 1 ; i >= 0 ; --i)
						{
							ship.adjustCargo(this.$KW_adder_mark_III_scavenger_cargo(), 1);
						};
					};
					break;

				case "hunter":
				case "KW_adder_mark_III-E_hunter":
											
					ship.primaryRole = "hunter";
									
					if(cargoLoad <= 1)
					{
						for(var i = this.$getRndInteger(3, 8) - 1 ; i >= 0 ; --i)
						{
							ship.adjustCargo(this.$KW_adder_mark_III_space_jockey_cargo(), 1);
						};
					};
					break;

				default: 
	
					break;
			};
		};
		
		// if there is an existing script in shipDied time to move it
		ship.script.$KW_adder_mark_III_shipDied_old = ship.script.shipDied;
		ship.script.shipDied = this.$KW_adder_mark_III_shipDied;	
	};
};	

this.$KW_adder_mark_III_shipDied = function $KW_adder_mark_III_shipDied(whom, why) 
{
	if(this.ship.dataKey.search(/KW_adder_mark_III/i) < 0 || this.ship.hasRole("escape-capsule") || this.ship.isPlayer)
	{
		return;
	}
	else
	{
		this.name = "KW_adder_mark_III";
		let dice = worldScripts.KW_adder_mark_III;
		let diceRoll = dice.$getRndInteger;
				
		let shipType = this.ship.dataKey;
		let shipBounty = this.ship.bounty;
		let shipPos = this.ship.position;
		let MRP01 = 0;
		let criminalCrew = 0;
		let pirateCrew = 0;

		if(worldScripts["MRP01_ressource_spawn"])  // Montanas Ressource Pack 01 OXP
		{
			MRP01 = 1;
		};
		
		if(shipBounty > 7 && shipBounty < 15)
		{
			criminalCrew = 1;
		};

		if(shipBounty > 14 || this.ship.isPirate)
		{
			pirateCrew = 1;
		};

		// if Montanas Ressource Pack 01 OXP is installed the containers from there are used, otherwise let the core-game handle it
		if(MRP01 == 1 && this.ship.cargoSpaceUsed > 0)
		{
			for(let i = this.ship.cargoList.length - 1 ; i >= 0 ; --i)
			{
				let cargoType = this.ship.cargoList[i].commodity;
				let cargoPod = ("MRP01_container_" + cargoType);
				let cargoCount = this.ship.cargoList[i].quantity;
				
				system.addShips(cargoPod, cargoCount, shipPos);
			};
		};

		switch(shipType) 
		{
			case "KW_adder_mark_III_01":
			
				if(criminalCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_green_criminal", 1, shipPos);
				}
				else if(pirateCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_green_pirate", 1, shipPos);
				}
				else
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_green", 1, shipPos);
				};
			
				if(MRP01 == 1 && diceRoll(1, 10) > 8)
				{
					system.addShips("MRP01_container_cash", 1, shipPos);
				};
				break;

			case "KW_adder_mark_III_02":
			
				if(criminalCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_blue_criminal", 1, shipPos);
				}
				else if(pirateCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_blue_pirate", 1, shipPos);
				}
				else
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_blue", 1, shipPos);
				};

				if(MRP01 == 1 && diceRoll(1, 10) > 8)
				{
					system.addShips("MRP01_container_cash", 1, shipPos);
				};
				break;
			
			case "KW_adder_mark_III-E_hunter":
			
				if(criminalCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_red_criminal", diceRoll(1, 2), shipPos);
				}
				else if(pirateCrew == 1)
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_red_pirate", diceRoll(1, 2), shipPos);
				}
				else
				{
					system.addShips("KW_adder_mark_III_escape_capsule_std_red", diceRoll(1, 2), shipPos);
				};
			
				if(MRP01 == 1 && diceRoll(1, 10) > 8)
				{
					system.addShips("MRP01_container_prisoners", 1, shipPos)
				};
				break;
				
			case "KW_adder_mark_III-E_pirate":

				system.addShips("KW_adder_mark_III_escape_capsule_std_red_pirate", 1, shipPos);
				
				if(MRP01 == 1 && diceRoll(1, 10) > 9)
				{
					system.addShips("MRP01_container_cash", 1, shipPos);
				};
				break;
	
			default:
				
				break;
		};
	};

	if(this.ship.script.$KW_adder_mark_III_shipDied_old)
	{
		this.ship.script.$KW_adder_mark_III_shipDied_old(whom, why);
	};
};

this.$KW_adder_mark_III_scavenger_cargo = function()
{
	const scavenger_cargo_array = ["alloys", "gold", "platinum", "computers", "machinery", "slaves"];

	// Montanas Ressource Pack 01 OXP
	if(worldScripts["MRP01_ressource_spawn"] && scavenger_cargo_array.indexOf("quirium_crystal") < 0)
	{
		scavenger_cargo_array.push("quirium_crystal");
	};
	
	let scavenger_cargo = 
	scavenger_cargo_array[Math.floor(Math.random() * scavenger_cargo_array.length)];
		
	return (scavenger_cargo);
};

this.$KW_adder_mark_III_rare_cargo = function()
{
	const rare_cargo_array = ["gold", "platinum", "gem_stones"];

	// medicine is part of several OXP's therefore a check of the market is required
	let goods = system.mainStation.market;
	for(let i in goods) 
	{
		if(goods[i].key == ["medicine"] && rare_cargo_array.indexOf("medicine") < 0)
		{
			rare_cargo_array.push("medicine");
		};
	}; 
	
	// Montanas Ressource Pack 01 OXP
	if(worldScripts["MRP01_ressource_spawn"] && rare_cargo_array.indexOf("quirium_crystal") < 0)
	{
		rare_cargo_array.push("quirium_crystal");
	};

	// Dictators OXP 2.0
	if(worldScripts["dictators_clergy_artifacts"] && rare_cargo_array.indexOf("quirium_crystal") < 0)
	{
		rare_cargo_array.push("holy_artifacts");
	};
	
	let rare_cargo = 
	rare_cargo_array[Math.floor(Math.random() * rare_cargo_array.length)];
		
	return (rare_cargo);
};

// food, medicine, booze and guns, what else you need for your trip ? :P
this.$KW_adder_mark_III_space_jockey_cargo = function()
{
	const space_jockey_cargo_array = ["firearms", "food", "liquor_wines"];

	 // Darkside Moonshine Distillery OXP
	if(worldScripts["witchfire-populator"] && space_jockey_cargo_array.indexOf("witchfire_whiskey") < 0)
	{
		space_jockey_cargo_array.push("witchfire_whiskey");
	};
	
	// medicine is part of several OXP's therefore a check of the market is required
	if(system.mainStation)
	{
		let goods = system.mainStation.market;
		for(let i in goods) 
		{
			if(goods[i].key == ["medicine"] && space_jockey_cargo_array.indexOf("medicine") < 0)
			{
				space_jockey_cargo_array.push("medicine");
			};
		};
	}; 

	let space_jockey_cargo = 
	space_jockey_cargo_array[Math.floor(Math.random() * space_jockey_cargo_array.length)];

	return (space_jockey_cargo);
};

this.$getRndInteger = function(min, max)
{
	return (Math.floor(Math.random() * (max - min + 1) ) + min);
};
